
pub trait Handle {
    fn get_handle(&self) -> u32;
}

/// Typed wrapper for a u32 handle
#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct CanvasFontHandle {
    pub(in crate::canvas) handle: u32
}

impl Handle for CanvasFontHandle {
    fn get_handle(&self) -> u32 {
        self.handle
    }
}

/// Typed wrapper for a u32 handle
#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct CanvasTextureHandle {
    pub(in crate::canvas) handle: u32
}

impl Handle for CanvasTextureHandle {
    fn get_handle(&self) -> u32 {
        self.handle
    }
}

/// Typed wrapper for a u32 handle
#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct CanvasImageHandle {
    pub(in crate::canvas) handle: u32
}

impl Handle for CanvasImageHandle {
    fn get_handle(&self) -> u32 {
        self.handle
    }
}

/// Typed wrapper for a u32 handle
#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct CanvasShaderHandle {
    pub(in crate::canvas) handle: u32
}

impl Handle for CanvasShaderHandle {
    fn get_handle(&self) -> u32 {
        self.handle
    }
}

/// Typed wrapper for a u32 handle
#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct CompiledGraphicsPipelineHandle {
    pub(in crate::canvas) handle: u32
}

impl Handle for CompiledGraphicsPipelineHandle {
    fn get_handle(&self) -> u32 {
        self.handle
    }
}


